/************************************************************************************
 *  File:     main.c
 *  Purpose:  Cortex-M0/0+/1 main file.
 *            Replace with your code.
 *  Date:     05 July 2013
 *  Info:     If __NO_SYSTEM_INIT is defined in the Build options,
 *            the startup code will not branch to SystemInit()
 *            and the function can be removed
 ************************************************************************************/

#define PORT_BASE_ADDR (0x41004400)
#define PORT_DIR0   *((volatile unsigned int*)(PORT_BASE_ADDR + 0x00 + 0x00))  // I/O 0-31
#define PORT_DIR1   *((volatile unsigned int*)(PORT_BASE_ADDR + 0x00 + 0x80))  // I/O 32-63
#define PORT_DIR0CLR *((volatile unsigned int*)(PORT_BASE_ADDR + 0x04 + 0x00))
#define PORT_DIR1CLR *((volatile unsigned int*)(PORT_BASE_ADDR + 0x04 + 0x80))
#define PORT_DIR0SET *((volatile unsigned int*)(PORT_BASE_ADDR + 0x08 + 0x00))
#define PORT_DIR1SET *((volatile unsigned int*)(PORT_BASE_ADDR + 0x08 + 0x80))
#define PORT_OUT0   *((volatile unsigned int*)(PORT_BASE_ADDR + 0x10 + 0x00))
#define PORT_OUT1   *((volatile unsigned int*)(PORT_BASE_ADDR + 0x10 + 0x80))
#define PORT_OUT0CLR *((volatile unsigned int*)(PORT_BASE_ADDR + 0x14 + 0x00))
#define PORT_OUT1CLR *((volatile unsigned int*)(PORT_BASE_ADDR + 0x14 + 0x80))
#define PORT_OUT0SET *((volatile unsigned int*)(PORT_BASE_ADDR + 0x18 + 0x00))
#define PORT_OUT1SET *((volatile unsigned int*)(PORT_BASE_ADDR + 0x18 + 0x80))

#define NVIC_AIRCR *((volatile unsigned int*)(0xE000ED0C))

volatile int Cnt;

#ifndef __NO_SYSTEM_INIT
void SystemInit()
{}
#endif


static void _Delay(int NumLoops) {
  volatile int DelayCnt;

  DelayCnt = NumLoops;
  do {} while (--DelayCnt);
}

/*********************************************************************
 *
 *  main()
 *
 *********************************************************************/

int main(void) {
  //
  // Project is configured for SAMD20 socket on Atmel STK600 generic socket board
  // Make sure that LED1 & PA2 are wired/bridged in order to make LED toggling work.
  //
  //
  // Configure PA02 as GPIO so we can toggle the LED
  //
  PORT_OUT0SET = (1 << 2); // LED intially off
  PORT_DIR0SET = (1 << 2); // PA02 == OUTPUT
  _Delay(100000);
  Cnt = 0;
  do {
    PORT_OUT0CLR = (1 << 2); // LED on PA2 on
    _Delay(10000);
    PORT_OUT0SET = (1 << 2); // LED on PA2 off
    _Delay(10000);
    Cnt++;
    if (Cnt == 50) {
      NVIC_AIRCR = 0x5FA0004;  // System reset
    }
  } while (1);
  return 0;
}
